<?php

define('SIGNATURE','adsense_inbox');

set_time_limit(0);

define('WP_USE_THEMES', false);
require_once('../../../wp-blog-header.php');
require_once('../../../wp-admin/admin-functions.php');
require_once('../../../wp-admin/admin-db.php');

include_once "mimedecode.php";

$options = get_option(SIGNATURE);

if (!isset($options['server']) ||  !isset($options['username']) || !isset($options['password'])) exit;

$config = array(
  'MAIL_SERVER'      => $options['server'],
  'MAIL_SERVER_PORT' => '110',
  'MAIL_USERID'      => $options['username'],
  'MAIL_PASSWORD'    => $options['password'],

  'DELETE_MAIL_AFTER_PROCESSING'=>1,
);

$emails = fetch_mail($config);

foreach ($emails as $email) {
  if ($email == NULL ) continue;
  
  $params = array(
    'include_bodies' => true,
    'decode_bodies'  => false,
    'decode_headers' => true,
    'input'          => $email,
  );

  $decoded = Mail_mimeDecode::decode($params);

  $content = get_content($decoded);

  if (isset($options['akismet']) && $options['akismet']==1) {
    include_once "Akismet.class.php";

    $WordPressAPIKey =  $options['akismet_key'];
    $WordPressAPIKey = '7c72bf3ca811';
    $MyBlogURL = get_bloginfo('home');

    $akismet = new Akismet($MyBlogURL ,$WordPressAPIKey);
    $akismet->setCommentAuthor($from);
    $akismet->setCommentAuthorEmail($email);
    $akismet->setCommentContent($content);

    if ($akismet->isCommentSpam()) continue;
  }


  if (preg_match("@^\"?([^\"]+)\"?\s*<([^>]+)>@", $decoded->headers['from'],$match)) {
    $from = $match[1];
    $email = $match[2];
  } elseif (preg_match("@^<?([^>]+)>?@",$decoded->headers['from'],$match)) {
    $email = $match[1];
    list($from) = split('@',$email);
  }

  $from = trim($from);

  $message_date = NULL;
  if (!empty($decoded->headers["date"])) {
    handle_message_encoding(
      $decoded->headers["content-transfer-encoding"],
      $decoded->ctype_parameters["charset"],
      $decoded->headers["date"]
    );
  }

  list($post_date,$post_date_gmt) = get_post_date($content, $message_date);

  $poster = 1;

  $subject = trim($decoded->headers['subject']);

  $options = get_option(SIGNATURE);

  unset($post_categories);

  $post_status = isset($options['poststatus'])?$options['poststatus']:'draft';

  if (isset($options['rules'])) {
    foreach($options['rules'] as $rule) {
      if (($rule['field']=='email' && $rule['value']==$email) || 
          ($rule['field']=='name' && $rule['value']==$from)) {
        if ($rule['action'] == 'drop') continue 2;
        elseif ($rule['action'] == 'move') {
          $post_categories = $rule['data'];
        } elseif ($rule['action'] == 'publish') {
          $post_status = 'publish';
        }
      }
    }
  }

  if (!isset($post_categories)) {
    $post_categories = category_exists($from);
    if (!$post_categories) {
      $post_categories = wp_create_category($from);
    }
  }

  if (!is_array($post_categories)) {
    $post_categories = array($post_categories);
  }

  /*
  handle_message_encoding(
    $decoded->headers["content-transfer-encoding"],
    $decoded->ctype_parameters["charset"],
    $content
  );
  */

  if (isset($options['cleans']) && count($options['cleans'])>0) {
    foreach($options['cleans'] as $clean) {
      if ($found = strpos($content,$clean)) {
        $content = substr($content,0,$found);
      }
    }
  }

  $content = nl2br($content);

  if (isset($options['disclaimer_allowed']) && $options['disclaimer_allowed']==1) {
    if (isset($options['disclaimer_before'])) {
      $content = nl2br($options['disclaimer_before']) . "\n<br /><br />\n". $content;
    }

    if (isset($options['disclaimer_before'])) {
      $content .= "\n<br /><br />\n" . nl2br($options['disclaimer_after']);
    }
  }

  $post_name = sanitize_title_with_dashes($subject);

  $details = array(
    'post_author'       => $poster,
    'post_date'         => $post_date,
    'post_date_gmt'     => $post_date_gmt,
    'post_content'      => preg_replace("/'/","\\'",$content),
    'post_title'        => preg_replace("/'/","\\'",$subject),
    'post_modified'     => $post_date,
    'post_modified_gmt'	=> $post_date_gmt,
    'ping_status'       => isset($options['pingstatus'])?$options['pingstatus']:1,
    'post_category'     => $post_categories,
    'comment_status'    => isset($options['commentsstatus'])?$options['commentsstatus']:1,
    'post_name'         => $post_name,
    'post_status'       => $post_status,
  );

  $post_ID = wp_insert_post($details);
  if ($post_ID && $post_status == 'draft') {
    add_post_meta($post_ID, 'poster', $email);
  }
}

function get_post_date(&$content, $message_date = NULL) {
  $delay = 0;
  if (eregi("delay:([0-9dhm]+)",$content,$matches)
    && trim($matches[1])) {
    if (eregi("([0-9]+)d",$matches[1],$dayMatches)) {
      $days = $dayMatches[1];
    }
    if (eregi("([0-9]+)h",$matches[1],$hourMatches)) {
      $hours = $hourMatches[1];
    }
    if (eregi("([0-9]+)m",$matches[1],$minuteMatches)) {
      $minutes = $minuteMatches[1];
    }
    $delay = (($days * 24 + $hours) * 60 + $minutes) * 60;
    $content = ereg_replace("delay:$matches[1]","",$content);
  }
  if (!empty($message_date)) {
    $dateInSeconds = strtotime($message_date);
  }
  else {
    $dateInSeconds = time() + $delay;
  }
  $post_date = gmdate('Y-m-d H:i:s',$dateInSeconds);
  $post_date_gmt = gmdate('Y-m-d H:i:s',$dateInSeconds);

  return(array($post_date,$post_date_gmt));
}

function convert_to_utf_8($encoding,$charset,&$body) {
  $charset = strtolower($charset);
  $encoding = strtolower($encoding);
  switch($charset) {
    case "iso-2022-jp":
      $body = iconv("ISO-2022-JP//TRANSLIT","UTF-8",$body);
      break;
    case "iso-8859-1":
      $body = utf8_encode($body);
      break;
  }
}

function handle_qp($encoding, &$body ) {
  if (strtolower($encoding) == 'quoted-printable' ) {
    $body = quoted_printable_decode($body);
  }
}

function get_content($decoded) {
  if ($decoded->ctype_primary == 'text' && $decoded->ctype_secondary == 'plain') {
    return filter_nl(rtrim($decoded->body,".\r\n"));
  } elseif ($decoded->ctype_primary=='multipart') {
    for($i=0;$i<count($decoded->parts);$i++) {
      $body = get_content($decoded->parts[$i]);
      if ($body!="") return filter_nl(rtrim($body,".\r\n"));
    }
  }
  return "";
}


function fetch_mail($config) {
  require_once('class-pop3.php');

  $pop3 = &new POP3();

  if ($pop3->connect($config["MAIL_SERVER"], $config["MAIL_SERVER_PORT"])) {
    $msg_count = $pop3->login($config["MAIL_USERID"], $config["MAIL_PASSWORD"]);
    if (!$msg_count) {
      $pop3->quit();
      return(array());
    }
  }

  for($i=1; $i <= $msg_count; $i++) {
    $emails[] = implode ('',$pop3->get($i));
    if ( $config["DELETE_MAIL_AFTER_PROCESSING"]) {
      if( !$pop3->delete($i) ) {
        $pop3->reset();
        return(array());
      }
    }
  }

  $pop3->quit();	
  return $emails;
}

function filter_nl($content) {
  $search = array ("/\r\n/","/\r/");
  $replace = array ("\n","\n");
  return preg_replace($search,$replace,$content);
}

function handle_message_encoding($encoding, $charset, &$body) {
  global $options;

  $charset = strtolower($charset);
  $encoding = strtolower($encoding);
  handle_qp($encoding, $body);
  if ($options['encoding']=='iso8859-1') {
    convert_to_iso_8859_1($encoding,$charset,$body);
  } else {
    convert_to_utf_8($encoding,$charset,$body);
  }
}

?>